SystemOrganization addCategory: #'Keymapping-Core'!

!TextMorph methodsFor: '*Keymapping-Core-override' stamp: 'BenjaminVanRyseghem 4/27/2012 11:13'!
handleKeystroke: anEvent 
	"System level event handling."
	| pasteUp |

	anEvent wasHandled
		ifTrue: [^ self].
	self allowsKeymapping
		ifTrue: [ self dispatchKeystrokeForEvent: anEvent ] .
	anEvent wasHandled
		ifTrue: [^ self].
	(self handlesKeyStroke: anEvent)
		ifFalse: [^ self].
	anEvent keyCharacter = Character tab
		ifTrue: ["Allow passing through text morph inside pasteups"
			pasteUp := self pasteUpMorphHandlingTabAmongFields.
			(self wouldAcceptKeyboardFocusUponTab
					and: [(pasteUp) notNil])
				ifTrue: [^ pasteUp tabHitWithEvent: anEvent]].
	self keyStroke: anEvent.
	anEvent wasHandled: true.! !

!TextMorph methodsFor: '*Keymapping-Core' stamp: 'ThierryGoubier 9/13/2012 11:17'!
kmDispatcher
	" Temporary : it's a bit of a hack to put this here."

	^ self
		valueOfProperty: #kmDispatcher
		ifAbsentPut: [ 
			| kmd |
			kmd := KMDispatcher target: self.
			kmd attachCategory: #TextMorph.
			kmd ]! !

!KeyboardEvent methodsFor: '*Keymapping-Core' stamp: 'GuillermoPolito 9/12/2011 17:14'!
altKeyPressed
	^self commandKeyPressed! !

!KeyboardEvent methodsFor: '*Keymapping-Core' stamp: 'GuillermoPolito 11/2/2011 22:32'!
asShortcut
	^ KMShortcut fromKeyboardEvent: self! !

!KeyboardEvent methodsFor: '*Keymapping-Core' stamp: 'DeboraFortini 11/1/2011 16:37'!
modifiedCharacter
    self flag: #hack.
    "Hack me.  When Ctrl is pressed, the key ascii value is not right and we have to do something ugly"
    ^(self controlKeyPressed and: [ (#(MacOSX Windows) includes: Smalltalk os current platformFamily) and: [ keyValue <= 26 ]])
        ifTrue: [ (self keyValue + $a asciiValue - 1) asCharacter ]    
        ifFalse: [ self keyCharacter ]! !

!TransformMorph methodsFor: '*Keymapping-Core' stamp: 'ThierryGoubier 9/13/2012 11:48'!
kmDispatcher
	" Don't track navigation keys here."

	^ self
		valueOfProperty: #kmDispatcher
		ifAbsentPut: [ 
			| kmd |
			kmd := KMDispatcher target: self.
			kmd ]! !

!PluggableTextMorph methodsFor: '*Keymapping-Core' stamp: 'ThierryGoubier 9/13/2012 11:48'!
kmDispatcher
	" Temporary : it's a bit of a hack to put this here."

	^ self
		valueOfProperty: #kmDispatcher
		ifAbsentPut: [ 
			| kmd |
			kmd := KMDispatcher target: self.
			kmd attachCategory: #TextMorph.
			kmd ]! !

!Integer methodsFor: '*Keymapping-Core' stamp: 'CamilloBruni 3/18/2011 23:16'!
asShortcut
	^ KMSingleKeyShortcut from: self asCharacter! !

!Morph methodsFor: '*Keymapping-Core' stamp: 'GuillermoPolito 5/31/2011 11:19'!
allowsKeymapping
	^ true! !

!Morph methodsFor: '*Keymapping-Core' stamp: 'GuillermoPolito 10/20/2011 17:44'!
attachKeymapCategory: aCategoryName
	self kmDispatcher attachCategory: aCategoryName.! !

!Morph methodsFor: '*Keymapping-Core' stamp: 'GuillermoPolito 10/20/2011 23:33'!
attachKeymapCategory: aCategoryName onProperty: aProperty
	self kmDispatcher attachCategory: aCategoryName onProperty: aProperty! !

!Morph methodsFor: '*Keymapping-Core' stamp: 'GuillermoPolito 10/20/2011 18:09'!
attachKeymapCategory: aCategoryName targetting: anObject
	self kmDispatcher attachCategory: aCategoryName targetting: anObject! !

!Morph methodsFor: '*Keymapping-Core' stamp: 'BenjaminVanRyseghem 2/20/2012 19:35'!
detachAllKeymapCategories

	self kmDispatcher detachAllKeymapCategories! !

!Morph methodsFor: '*Keymapping-Core' stamp: 'BenjaminVanRyseghem 2/20/2012 19:23'!
detachKeymapCategory: aCategoryName

	self kmDispatcher detachKeymapCategory: aCategoryName.! !

!Morph methodsFor: '*Keymapping-Core' stamp: 'BenjaminVanRyseghem 2/20/2012 19:23'!
detachKeymapCategory: aCategoryName targetting: anObject

	self kmDispatcher detachKeymapCategory: aCategoryName targetting: anObject! !

!Morph methodsFor: '*Keymapping-Core' stamp: 'GuillermoPolito 3/14/2011 00:03'!
dispatchKeystrokeForEvent: evt 
	self kmDispatcher dispatchKeystroke: evt 
! !

!Morph methodsFor: '*Keymapping-Core-override' stamp: 'BenjaminVanRyseghem 4/27/2012 11:15'!
handleKeystroke: anEvent 
	"System level event handling."
	
	anEvent wasHandled
		ifTrue: [^ self].
	
	self allowsKeymapping 
		ifTrue: [
			self dispatchKeystrokeForEvent: anEvent.
			anEvent wasHandled
				ifTrue: [^ self]].	
	
	(self handlesKeyStroke: anEvent)
		ifFalse: [^ self].
	anEvent wasHandled: true.
	self keyStroke: anEvent.
	^ self eventHandler ifNotNil: [:handler | handler keyStroke: anEvent fromMorph: self ].! !

!Morph methodsFor: '*Keymapping-Core' stamp: 'SeanDeNigris 7/9/2012 23:40'!
hasKeymapCategoryNamed: aString

	^ self kmDispatcher targets anySatisfy: [ :e | e category name = aString ].! !

!Morph methodsFor: '*Keymapping-Core' stamp: 'ThierryGoubier 9/13/2012 11:11'!
kmDispatcher
	" Temporary : it's a bit of a hack to put this here."

	^ self
		valueOfProperty: #kmDispatcher
		ifAbsentPut: [ 
			| kmd |
			kmd := KMDispatcher target: self.
			kmd attachCategory: #Morph.
			kmd ]! !

!Morph methodsFor: '*Keymapping-Core' stamp: 'GuillermoPolito 9/12/2011 16:39'!
on: aShortcut do: anAction
	self kmDispatcher on: aShortcut asShortcut do: anAction! !

Announcement subclass: #KMCompleteMatch
	instanceVariableNames: 'event source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Core'!

!KMCompleteMatch class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/3/2012 14:43'!
event: event from: source

	^ self new
		event: event;
		source: source;
		yourself! !

!KMCompleteMatch methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/3/2012 12:55'!
event
	^ event! !

!KMCompleteMatch methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/3/2012 12:55'!
event: anObject
	event := anObject! !

!KMCompleteMatch methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/3/2012 14:43'!
source
	^ source! !

!KMCompleteMatch methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/3/2012 14:43'!
source: anObject
	source := anObject! !

Announcement subclass: #KMPartialMatch
	instanceVariableNames: 'event source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Core'!

!KMPartialMatch commentStamp: '<historical>' prior: 0!
A KMPartialMatch is an announcement raised when a partial match is completed!

!KMPartialMatch class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/3/2012 14:42'!
event: event from: source

	^ self new
		event: event;
		source: source;
		yourself! !

!KMPartialMatch methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/3/2012 12:52'!
event
	^ event! !

!KMPartialMatch methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/3/2012 12:52'!
event: anObject
	event := anObject! !

!KMPartialMatch methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/3/2012 14:42'!
source
	^ source! !

!KMPartialMatch methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/3/2012 14:42'!
source: anObject
	source := anObject! !

Object subclass: #KMBuffer
	instanceVariableNames: 'buffer currentEvent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Core'!

KMBuffer class
	instanceVariableNames: 'uniqueInstance'!

KMBuffer class
	instanceVariableNames: 'uniqueInstance'!

!KMBuffer class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 6/24/2012 12:02'!
resetUniqueInstance
	uniqueInstance := nil! !

!KMBuffer class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 6/24/2012 12:02'!
uniqueInstance
	^uniqueInstance ifNil: [ uniqueInstance := self new ].! !

!KMBuffer class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 6/24/2012 12:31'!
uniqueInstance: aBuffer
	uniqueInstance := aBuffer.! !

!KMBuffer methodsFor: 'adding' stamp: 'BenjaminVanRyseghem 7/3/2012 15:43'!
addEvent: anEvent

	buffer add: anEvent.
	currentEvent := anEvent.! !

!KMBuffer methodsFor: 'accessing' stamp: 'GuillermoPolito 6/24/2012 12:08'!
buffer
	^buffer! !

!KMBuffer methodsFor: 'clearing' stamp: 'BenjaminVanRyseghem 7/3/2012 15:38'!
clearBuffer

	currentEvent := nil.
	buffer removeAll.! !

!KMBuffer methodsFor: 'matching' stamp: 'BenjaminVanRyseghem 7/3/2012 14:55'!
completeMatch

	currentEvent ifNotNil:[ currentEvent wasHandled: true ].
	self clearBuffer.! !

!KMBuffer methodsFor: 'initialize-release' stamp: 'GuillermoPolito 6/24/2012 12:03'!
initialize
	buffer := OrderedCollection new.! !

!KMBuffer methodsFor: 'matching' stamp: 'BenjaminVanRyseghem 7/3/2012 15:45'!
partialMatch

	KMLog log: 'Partial match: ', currentEvent printString.
	currentEvent ifNotNil:[ currentEvent wasHandled: true ].! !

Object subclass: #KMCategory
	instanceVariableNames: 'name platforms'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Core'!

!KMCategory commentStamp: 'GuillermoPolito 12/14/2010 21:32' prior: 0!
I am a keymap category.  I represent a set of keymaps that can be attached to a morph, so morphs can share my keymaps.!

!KMCategory class methodsFor: 'instance creation' stamp: 'CamilloBruni 3/18/2011 23:11'!
named: aCategorySymbol
	^ (self new)
		name: aCategorySymbol;
		yourself! !

!KMCategory methodsFor: 'associating' stamp: 'GuillermoPolito 1/21/2012 20:55'!
addKeymapEntry: aKeymapEntry 
	self commonEntries add: aKeymapEntry.! !

!KMCategory methodsFor: 'associating' stamp: 'GuillermoPolito 1/21/2012 20:55'!
addKeymapEntry: aKeymapEntry at: aPlatform
	(self entriesAt: aPlatform) add: aKeymapEntry! !

!KMCategory methodsFor: 'associating' stamp: 'GuillermoPolito 10/21/2011 00:40'!
allEntries
	^self commonEntries, self platformEntries! !

!KMCategory methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
categoryName
	^ name! !

!KMCategory methodsFor: 'associating' stamp: 'GuillermoPolito 10/21/2011 00:23'!
commonEntries
	^self entriesAt: #all! !

!KMCategory methodsFor: 'accessing' stamp: 'GuillermoPolito 1/21/2012 20:50'!
entriesAt: aPlatform
	platforms ifNil: [ platforms := Dictionary new ].
	^platforms at: aPlatform ifAbsentPut: [ KMStorage new ].! !

!KMCategory methodsFor: 'associating' stamp: 'GuillermoPolito 1/21/2012 20:56'!
hasKeymapNamed: aKeymapEntryName
	^self allEntries hasKeymapNamed: aKeymapEntryName! !

!KMCategory methodsFor: 'associating' stamp: 'GuillermoPolito 1/21/2012 20:57'!
hasKeymapNamed: aKeymapEntryName at: aPlatform
	^ (self entriesAt: aPlatform) hasKeymapNamed: aKeymapEntryName! !

!KMCategory methodsFor: 'associating' stamp: 'GuillermoPolito 1/21/2012 20:57'!
keymapNamed: aKeymapEntryName
	^self allEntries keymapNamed: aKeymapEntryName! !

!KMCategory methodsFor: 'associating' stamp: 'GuillermoPolito 1/21/2012 20:58'!
keymapNamed: aKeymapEntryName at: aPlatform
	^(self entriesAt: aPlatform) keymapNamed: aKeymapEntryName! !

!KMCategory methodsFor: 'accessing' stamp: 'GuillermoPolito 1/21/2012 21:02'!
keymaps
	^self allEntries keymaps! !

!KMCategory methodsFor: 'testing' stamp: 'GuillermoPolito 10/21/2011 00:37'!
matches: aString
	^ self keymaps anySatisfy: [ :entry | 
		entry matches: aString ]! !

!KMCategory methodsFor: 'testing' stamp: 'GuillermoPolito 10/21/2011 00:37'!
matchesCompletely: aString
	^ self keymaps anySatisfy: [ :entry | 
		entry matchesCompletely: aString ]! !

!KMCategory methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
name
	^ name! !

!KMCategory methodsFor: 'accessing' stamp: 'GuillermoPolito 12/14/2010 00:58'!
name: aCategorySymbol 
	name := aCategorySymbol ! !

!KMCategory methodsFor: 'matching' stamp: 'GuillermoPolito 10/20/2011 15:55'!
onMatchWith: anEventBuffer notify: aMatchListener andDo: aBlock
	self keymaps do: [ :entry | 
		entry onMatchWith: anEventBuffer 
			notify: aMatchListener 
			andDo: aBlock ].! !

!KMCategory methodsFor: 'associating' stamp: 'GuillermoPolito 10/21/2011 00:50'!
platformEntries
	^self entriesAt: Smalltalk os current platformFamily! !

Object subclass: #KMCategoryTarget
	instanceVariableNames: 'target category morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Core'!

!KMCategoryTarget class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 10/20/2011 19:05'!
target: aTarget morph: aMorph category: aCategory
	^self new
		target: aTarget;
		category: aCategory;
		morph: aMorph;
		yourself! !

!KMCategoryTarget methodsFor: 'accessing' stamp: 'GuillermoPolito 10/20/2011 18:37'!
category: aCategory
	category := aCategory! !

!KMCategoryTarget methodsFor: 'matching' stamp: 'GuillermoPolito 10/21/2011 09:31'!
completeMatch: aKeymap buffer: aBuffer
	aKeymap action cull: target value cull: morph cull: aBuffer first! !

!KMCategoryTarget methodsFor: 'accessing' stamp: 'GuillermoPolito 10/20/2011 19:05'!
morph: aMorph
	morph := aMorph! !

!KMCategoryTarget methodsFor: 'matching' stamp: 'GuillermoPolito 10/20/2011 18:53'!
noMatch
	"do nothing"
	! !

!KMCategoryTarget methodsFor: 'matching' stamp: 'GuillermoPolito 10/20/2011 18:53'!
partialMatch
	"do nothing"
	! !

!KMCategoryTarget methodsFor: 'printing' stamp: 'SeanDeNigris 7/17/2012 09:04'!
printOn: aStream

	aStream
		nextPutAll: 'aKMCategoryTarget(';
		nextPutAll: (category name ifNil: 'nil' ifNotNil: [ :n | n printString ]);
		nextPutAll: ')'.! !

!KMCategoryTarget methodsFor: 'accessing' stamp: 'GuillermoPolito 10/20/2011 18:37'!
target: aTarget
	target := aTarget! !

!KMCategoryTarget methodsFor: 'matching' stamp: 'BenjaminVanRyseghem 7/3/2012 14:47'!
verifyMatchWith: anEventBuffer notifying: aListener thenDoing: anAction
	self flag: #fixme. "ugly hack with array of listeners"
	category 
		onMatchWith:  anEventBuffer
		notify: { self . aListener } " first we have to tell the dispatcher "
		andDo: anAction! !

Object subclass: #KMDispatcher
	instanceVariableNames: 'target currentEvent targets morph directKeymaps perInstanceOnly'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Core'!

!KMDispatcher commentStamp: '<historical>' prior: 0!
I'm an object that saves a buffer of keyevents for the morph I'm attached.
I am the one that dispatches the single and multiple shortcuts.
If the morph has a keymap that matches the keyboard event, I tell the keymap event to execute with the morph I'm attached.

I can be told to use only per instance keymaps with perInstanceOnly:!

!KMDispatcher class methodsFor: 'instance creation' stamp: 'GuillermoPolito 5/30/2011 01:26'!
target: aTarget
	^ self target: #yourself morph: aTarget! !

!KMDispatcher class methodsFor: 'instance creation' stamp: 'GuillermoPolito 5/31/2011 11:02'!
target: aTargetSelector morph: aMorph
	^ (self new)
		target: (KMTarget for: aTargetSelector in: aMorph);
		yourself! !

!KMDispatcher methodsFor: 'match' stamp: 'BenjaminVanRyseghem 7/3/2012 12:50'!
announcer

	^ self target announcer! !

!KMDispatcher methodsFor: 'building' stamp: 'GuillermoPolito 10/20/2011 19:20'!
attachCategory: aCategoryName
	self attachCategory: aCategoryName targetting: morph! !

!KMDispatcher methodsFor: 'building' stamp: 'GuillermoPolito 10/20/2011 23:35'!
attachCategory: aCategoryName onProperty: aProperty
	self targets add: (KMCategoryTarget 
						target: [ morph perform: aProperty ] 
						morph: morph 
						category: (KMRepository default categoryForName: aCategoryName) )! !

!KMDispatcher methodsFor: 'building' stamp: 'SeanDeNigris 7/11/2012 10:08'!
attachCategory: aCategoryName targetting: anObject
	
	| isAlreadyAttached |
	isAlreadyAttached := self targets anySatisfy: [ :e | 
			self flag: 'Maybe the following line should be reified as KMCategoryTarget>>=... Guille? - SeanDeNigris'.
			e category name = aCategoryName and: [ e target = anObject and: [ e morph = morph ] ] ].
	isAlreadyAttached ifFalse: [ | category categoryTarget |
			category := KMRepository default categoryForName: aCategoryName.
			categoryTarget := KMCategoryTarget target: anObject morph: morph category: category.
			self targets add: categoryTarget ].! !

!KMDispatcher methodsFor: 'match' stamp: 'GuillermoPolito 6/24/2012 12:19'!
buffer
	^ KMBuffer uniqueInstance buffer! !

!KMDispatcher methodsFor: 'match' stamp: 'ThierryGoubier 9/13/2012 11:41'!
completeMatch: aKeymapEntry buffer: aBuffer
	KMLog log: 'Complete match: ', aKeymapEntry printString, ' in: ', morph printString.
	KMBuffer uniqueInstance completeMatch.
	self announcer announce: (KMCompleteMatch event: currentEvent from: self).! !

!KMDispatcher methodsFor: 'building' stamp: 'BenjaminVanRyseghem 2/20/2012 19:36'!
detachAllKeymapCategories

	self targets removeAll! !

!KMDispatcher methodsFor: 'building' stamp: 'BenjaminVanRyseghem 2/20/2012 22:41'!
detachKeymapCategory: aCategoryName

	self detachKeymapCategory: aCategoryName targetting: morph! !

!KMDispatcher methodsFor: 'building' stamp: 'SeanDeNigris 7/11/2012 10:16'!
detachKeymapCategory: aCategoryName targetting: anObject

	| categoryTarget |
	categoryTarget := self targets
		detect: [ :tgt | tgt target = anObject and: [ tgt category name = aCategoryName ] ]
		ifNone: [ self error: 'Category ', aCategoryName, ' is not attached to ', morph asString ].
	self targets remove: categoryTarget.! !

!KMDispatcher methodsFor: 'dispatching' stamp: 'GuillermoPolito 10/20/2011 19:27'!
directKeymaps
	^directKeymaps ifNil: [ directKeymaps := KMCategory new ]! !

!KMDispatcher methodsFor: 'dispatching' stamp: 'BenjaminVanRyseghem 7/3/2012 14:47'!
dispatch: anEventBuffer
	| association match |
	self keymapObservers do: [ :aTarget | 
		"nice hack to stop in the first listener"
		aTarget 
			verifyMatchWith: anEventBuffer 
			notifying: self
			thenDoing: [ ^self ] ].
	self noMatch! !

!KMDispatcher methodsFor: 'dispatching' stamp: 'ThierryGoubier 9/12/2012 10:10'!
dispatchKeystroke: aKeyEvent
	| currentTarget |
	KMLog log: aKeyEvent printString, String cr.

	KMBuffer uniqueInstance addEvent: aKeyEvent.

	currentTarget := self target.
	[ aKeyEvent wasHandled not and: [ currentTarget notNil ] ]
		whileTrue: [
			currentTarget dispatch: KMBuffer uniqueInstance buffer.
			currentTarget := currentTarget ownerTarget.
		].
	
	aKeyEvent wasHandled
		ifTrue: [ ^ self ].
	
	KMBuffer uniqueInstance clearBuffer.
	(aKeyEvent controlKeyPressed or: [ aKeyEvent commandKeyPressed ])
		ifTrue: [ aKeyEvent wasHandled: true ]! !

!KMDispatcher methodsFor: 'initialize' stamp: 'GuillermoPolito 6/24/2012 12:28'!
initialize
	super initialize.! !

!KMDispatcher methodsFor: 'dispatching' stamp: 'ThierryGoubier 9/12/2012 10:03'!
keymapObservers
	| o |
	o := OrderedCollection with: self perInstanceTarget.
	self perInstanceOnly
		ifFalse: [ 
			o
				addAll: self targets;
				addAll: self staticTargets ].
	^ o! !

!KMDispatcher methodsFor: 'match' stamp: 'GuillermoPolito 6/24/2012 12:12'!
noMatch! !

!KMDispatcher methodsFor: 'building' stamp: 'GuillermoPolito 1/21/2012 21:34'!
on: aShortcut do: anAction
	self directKeymaps 
		addKeymapEntry: (KMKeymap
			shortcut: aShortcut 
			action: anAction)! !

!KMDispatcher methodsFor: 'match' stamp: 'BenjaminVanRyseghem 7/3/2012 17:52'!
partialMatch
	| event |
	KMBuffer uniqueInstance partialMatch.
	event := KMBuffer uniqueInstance currentEvent.
	event isKeyboard not ifTrue: [ event := nil ].
	self announcer announce: (KMPartialMatch event: event from: self).! !

!KMDispatcher methodsFor: 'accessing' stamp: 'ThierryGoubier 9/12/2012 09:52'!
perInstanceOnly
	perInstanceOnly isNil
		ifTrue: [ perInstanceOnly := false ].
	^ perInstanceOnly! !

!KMDispatcher methodsFor: 'accessing' stamp: 'ThierryGoubier 9/12/2012 09:49'!
perInstanceOnly: aBoolean
	perInstanceOnly := aBoolean! !

!KMDispatcher methodsFor: 'dispatching' stamp: 'GuillermoPolito 10/20/2011 19:30'!
perInstanceTarget
	^KMCategoryTarget target: morph morph: morph category: self directKeymaps.! !

!KMDispatcher methodsFor: 'initialize' stamp: 'GuillermoPolito 1/21/2012 21:31'!
reset
    directKeymaps := nil! !

!KMDispatcher methodsFor: 'dispatching' stamp: 'GuillermoPolito 11/2/2011 22:18'!
staticTargets
	self flag: #deprecated. "static targets should not be used any more"

	^(KMRepository default categoriesForClass: target realTarget class) 
		collect: [ :cat | KMCategoryTarget 
						target: target realTarget 
						morph: target morph 
						category: cat ].! !

!KMDispatcher methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
target
	^ target! !

!KMDispatcher methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/3/2012 14:55'!
target: aTarget
	target := aTarget.
	morph := target morph.
	"self announcer weak
		on: MorphLostFocus send: #clearBuffer to: KMBuffer uniqueInstance."! !

!KMDispatcher methodsFor: 'dispatching' stamp: 'GuillermoPolito 10/20/2011 18:20'!
targets
	^targets ifNil: [ targets := Set new ]! !

Object subclass: #KMFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Core'!

!KMFactory commentStamp: 'GuillermoPolito 2/24/2011 23:43' prior: 0!
I am a class used to access some of the main classes of Keymapping. See my class side to have an idea of what can I give you.!

!KMFactory class methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
keymapContainer
	^ KMRepository default! !

Object subclass: #KMKeymap
	instanceVariableNames: 'action name shortcut defaultShortcut description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Core'!

!KMKeymap commentStamp: 'GuillermoPolito 12/14/2010 21:33' prior: 0!
I am the real keymap.  I have an action to evaluate when my keymap sequence is pressed.!

!KMKeymap class methodsFor: 'instance creation' stamp: 'GuillermoPolito 10/18/2011 20:49'!
named: keymapName shortcut: aShortcut action: anAction
	^ (self new)
		name: keymapName;
		defaultShortcut: aShortcut;
		shortcut: aShortcut;
		action: anAction;
		yourself! !

!KMKeymap class methodsFor: 'instance creation' stamp: 'GuillermoPolito 4/6/2012 13:27'!
named: keymapName shortcut: aShortcut action: anAction description: aDescription
	^ (self new)
		name: keymapName;
		defaultShortcut: aShortcut;
		shortcut: aShortcut;
		action: anAction;
		description: aDescription;
		yourself! !

!KMKeymap class methodsFor: 'instance creation' stamp: 'GuillermoPolito 1/21/2012 21:34'!
shortcut: aShortcut action: anAction
	^ (self new)
		defaultShortcut: aShortcut;
		shortcut: aShortcut;
		action: anAction;
		yourself! !

!KMKeymap methodsFor: 'comparing' stamp: 'MarianoMartinezPeck 5/30/2012 17:12'!
= aKeymap
	self == aKeymap
		ifTrue: [ ^ true ].
	self species = aKeymap species
		ifFalse: [ ^ false ].
	^action = aKeymap action and: [ shortcut = aKeymap shortcut and: [ name = aKeymap name ] ]! !

!KMKeymap methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
action
	^ action! !

!KMKeymap methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:35'!
action: anAction
	action := anAction! !

!KMKeymap methodsFor: 'accessing' stamp: 'GuillermoPolito 10/18/2011 20:49'!
defaultShortcut
	^defaultShortcut! !

!KMKeymap methodsFor: 'accessing' stamp: 'GuillermoPolito 10/18/2011 20:49'!
defaultShortcut: aShortcut
	defaultShortcut := aShortcut.! !

!KMKeymap methodsFor: 'accessing' stamp: 'GuillermoPolito 4/6/2012 13:28'!
description
	^description ifNil: [ '' ]! !

!KMKeymap methodsFor: 'accessing' stamp: 'GuillermoPolito 4/6/2012 13:28'!
description: aDescription
	description := aDescription asString! !

!KMKeymap methodsFor: 'enabling/disabling' stamp: 'SeanDeNigris 7/8/2012 23:14'!
disable

	self shortcut: KMNoShortcut new.! !

!KMKeymap methodsFor: 'executing' stamp: 'GuillermoPolito 10/20/2011 18:58'!
executeActionTargetting: target
	^ self action cull: target cull: target! !

!KMKeymap methodsFor: 'accessing' stamp: 'GuillermoPolito 9/12/2011 17:32'!
hasName
	^name notNil! !

!KMKeymap methodsFor: 'comparing' stamp: 'GuillermoPolito 9/12/2011 17:49'!
hash
	^action hash bitXor: (shortcut hash bitXor: name hash)! !

!KMKeymap methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
key
	^ name! !

!KMKeymap methodsFor: 'matching' stamp: 'BenjaminVanRyseghem 7/3/2012 13:42'!
matches: anEventBuffer

	^ anEventBuffer
		ifEmpty: [ false ]
		ifNotEmpty: [ self shortcut matches: anEventBuffer ]! !

!KMKeymap methodsFor: 'matching' stamp: 'GuillermoPolito 11/2/2011 22:33'!
matchesCompletely: aShortcut
	^ self shortcut = aShortcut asShortcut! !

!KMKeymap methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
name
	^ name! !

!KMKeymap methodsFor: 'accessing' stamp: 'GuillermoPolito 12/26/2010 22:14'!
name: aName
	name := aName! !

!KMKeymap methodsFor: 'matching' stamp: 'BenjaminVanRyseghem 7/3/2012 12:57'!
notifyCompleteMatchTo: aListener buffer: aBuffer
	| listeners |
	aListener isCollection ifTrue: [ listeners := aListener ] ifFalse: [ listeners := { aListener } ].
	listeners do: [ :l | l completeMatch: self buffer: aBuffer ].! !

!KMKeymap methodsFor: 'matching' stamp: 'GuillermoPolito 10/20/2011 18:56'!
notifyPartialMatchTo: aListener
	| listeners |
	aListener isCollection ifTrue: [ listeners := aListener ] ifFalse: [ { aListener } ].
	listeners do: [ :l | l partialMatch ].! !

!KMKeymap methodsFor: 'matching' stamp: 'GuillermoPolito 10/20/2011 19:11'!
onMatchWith: anEventBuffer notify: aMatchListener andDo: anAction
	(self matches: anEventBuffer)
			ifTrue: [ 
				(self matchesCompletely: anEventBuffer)
					ifTrue: [ self notifyCompleteMatchTo: aMatchListener buffer: anEventBuffer ]
					ifFalse: [ self notifyPartialMatchTo: aMatchListener ].
					anAction value.
				] ! !

!KMKeymap methodsFor: 'accessing' stamp: 'GuillermoPolito 5/31/2011 12:50'!
printOn: aStream
	aStream 
		nextPutAll: self name printString;
		nextPutAll: ' on ';
		nextPutAll: self shortcut printString;
		nextPutAll: ' do ' ;
		nextPutAll: self action printString;
		cr.    ! !

!KMKeymap methodsFor: 'enabling/disabling' stamp: 'SeanDeNigris 7/8/2012 23:27'!
reset

	self shortcut: self defaultShortcut.! !

!KMKeymap methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
shortcut
	^ shortcut! !

!KMKeymap methodsFor: 'accessing' stamp: 'GuillermoPolito 3/14/2011 02:54'!
shortcut: aShortcut
	shortcut := aShortcut.! !

!KMKeymap methodsFor: 'accessing' stamp: 'GuillermoPolito 11/6/2011 10:17'!
shortcutHasChangedBy: aShortcut
	self defaultShortcut = self shortcut ifTrue: [ self shortcut: aShortcut ].
	self defaultShortcut: aShortcut! !

Object subclass: #KMLog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Core'!

KMLog class
	instanceVariableNames: 'debug'!

KMLog class
	instanceVariableNames: 'debug'!

!KMLog class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/1/2011 17:50'!
log: aMessage
	(debug notNil and: [ debug ]) ifTrue: [ Transcript show: aMessage ]! !

!KMLog class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/1/2011 17:51'!
removeDebug
	debug := false! !

!KMLog class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/1/2011 17:51'!
setDebug
	debug := true! !

Object subclass: #KMNoKeymap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Core'!

!KMNoKeymap commentStamp: 'GuillermoPolito 2/24/2011 23:43' prior: 0!
I am a Null object representing the absence of a Keymap.!

!KMNoKeymap methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
shortcut
	^ KMNoShortcut new! !

Object subclass: #KMRepository
	instanceVariableNames: 'categories categoryHolders'
	classVariableNames: 'Singleton'
	poolDictionaries: ''
	category: 'Keymapping-Core'!

!KMRepository commentStamp: 'GuillermoPolito 12/14/2010 21:37' prior: 0!
I have a singleton instance which can be accessed by executing the following:
"self default"

I am currently a god object to be refactored =D.!

!KMRepository class methodsFor: 'instance creation' stamp: 'CamilloBruni 3/18/2011 23:11'!
default
	^ Singleton ifNil: [ Singleton := self new ]! !

!KMRepository class methodsFor: 'instance creation' stamp: 'CamilloBruni 3/18/2011 23:11'!
default: aDefault
	^ Singleton := aDefault! !

!KMRepository class methodsFor: 'instance creation' stamp: 'GuillermoPolito 1/21/2012 21:31'!
reset
	self default: self new.
	KMPragmaKeymapBuilder uniqueInstance reset.
	KMDispatcher allInstancesDo: #reset! !

!KMRepository methodsFor: 'associating' stamp: 'GuillermoPolito 12/15/2010 01:59'!
addCategory: aCategory
	(self includesCategory: aCategory)
		ifTrue: [ self error: 'a Category named ' , aCategory name, ' already exists.' ].
	self categories at: aCategory name put: aCategory.! !

!KMRepository methodsFor: 'keymaps' stamp: 'GuillermoPolito 12/26/2010 22:05'!
attach: aCategory to: aClass
	(self categoryHolders includesKey: aClass) 
		ifFalse: [ self categoryHolders at: aClass put: Set new ].
	
	(self categoryHolders at: aClass) add: aCategory! !

!KMRepository methodsFor: 'keymaps' stamp: 'GuillermoPolito 3/13/2011 17:58'!
attachCategoryName: aCategorySymbol to: aClass 
	self attach: (self ensureCategoryByName: aCategorySymbol) to: aClass.! !

!KMRepository methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
categories
	^ categories ifNil: [ categories := Dictionary new ]! !

!KMRepository methodsFor: 'accessing' stamp: 'GuillermoPolito 11/2/2011 22:14'!
categoriesForClass: aClass
	| classCategories superclassCategories |
	aClass == Object
		ifTrue: [ ^ Set new ].
	classCategories := self categoryHolders at: aClass ifAbsent: [ Set new ].
	superclassCategories := self categoriesForClass: aClass superclass.
	^ classCategories union: superclassCategories! !

!KMRepository methodsFor: 'accessing' stamp: 'GuillermoPolito 5/31/2011 11:26'!
categoryForName: aCategorySymbol
	^ self categories at: aCategorySymbol ifAbsentPut: [ KMCategory named: aCategorySymbol ]! !

!KMRepository methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
categoryHolders
	^ categoryHolders ifNil: [ categoryHolders := Dictionary new ]! !

!KMRepository methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
ensureCategoryByName: aCategorySymbol
	| category |
	(self includesCategoryNamed: aCategorySymbol)
		ifFalse: [ 
			category := KMCategory named: aCategorySymbol.
			self addCategory: category ]
		ifTrue: [ category := self categoryForName: aCategorySymbol ].
	^ category! !

!KMRepository methodsFor: 'testing' stamp: 'CamilloBruni 3/18/2011 23:11'!
includesCategory: aCategory
	^ self categories includes: aCategory! !

!KMRepository methodsFor: 'testing' stamp: 'CamilloBruni 3/18/2011 23:11'!
includesCategoryNamed: aCategorySymbol
	^ self categories includesKey: aCategorySymbol! !

!KMRepository methodsFor: 'accessing' stamp: 'GuillermoPolito 4/6/2012 13:25'!
initializeKeymap: shortcutName executingOn: shortcut doing: action inCategory: categoryName platform: aPlatform
	^self initializeKeymap: shortcutName executingOn: shortcut doing: action inCategory: categoryName platform: aPlatform description: ''! !

!KMRepository methodsFor: 'accessing' stamp: 'GuillermoPolito 4/6/2012 13:25'!
initializeKeymap: shortcutName executingOn: shortcut doing: action inCategory: categoryName platform: aPlatform description: aDescription
	| category entry |
	category := self ensureCategoryByName: categoryName.
	(category hasKeymapNamed: shortcutName at: aPlatform) not
		ifTrue: [
			entry := shortcut asShortcut named: shortcutName do: action withDescription: aDescription.
			category addKeymapEntry: entry at: aPlatform.
			]
		ifFalse:[
			entry := category keymapNamed: shortcutName at: aPlatform.
			entry shortcutHasChangedBy: shortcut asShortcut.
			entry action: action.
			entry description: aDescription
			]! !

!KMRepository methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
keymapNamed: aKeymapName inCategory: aKeymapCategory
	^ (self categoryForName: aKeymapCategory) keymapNamed: aKeymapName! !

Object subclass: #KMStorage
	instanceVariableNames: 'namedRegistry annonimousRegistry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Core'!

!KMStorage methodsFor: 'accessing' stamp: 'GuillermoPolito 1/21/2012 21:02'!
, aKMStorage
	^self class new
		addAll: self keymaps;
		addAll: aKMStorage keymaps.! !

!KMStorage methodsFor: 'accessing' stamp: 'GuillermoPolito 1/21/2012 21:00'!
add: aKeymap
	aKeymap hasName
		ifTrue: [ namedRegistry at: aKeymap name put: aKeymap ]
		ifFalse: [ annonimousRegistry add: aKeymap ].! !

!KMStorage methodsFor: 'accessing' stamp: 'GuillermoPolito 1/21/2012 20:52'!
addAll: keymaps
	keymaps do: [ :km | self add: km ].! !

!KMStorage methodsFor: 'accessing' stamp: 'GuillermoPolito 1/21/2012 20:56'!
hasKeymapNamed: aKmName
	^namedRegistry includesKey: aKmName! !

!KMStorage methodsFor: 'initialize-release' stamp: 'GuillermoPolito 1/21/2012 20:49'!
initialize
	annonimousRegistry := Set new.
	namedRegistry := Dictionary new.! !

!KMStorage methodsFor: 'accessing' stamp: 'GuillermoPolito 1/21/2012 20:57'!
keymapNamed: aKmName
	^namedRegistry at: aKmName! !

!KMStorage methodsFor: 'accessing' stamp: 'GuillermoPolito 1/21/2012 20:55'!
keymaps
	^annonimousRegistry , namedRegistry values! !

!KMStorage methodsFor: 'accessing' stamp: 'GuillermoPolito 1/21/2012 21:01'!
size
	^self keymaps size! !

Object subclass: #KMTarget
	instanceVariableNames: 'realTarget morph targetSelector directKeymaps perInstanceCategories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Core'!

!KMTarget commentStamp: 'GuillermoPolito 2/24/2011 23:44' prior: 0!
I am the reification of the Keymap target.  I am the one that receives the actions.!

!KMTarget class methodsFor: 'instance creation' stamp: 'GuillermoPolito 5/31/2011 11:11'!
for: aTarget in: aMorph
	^ (self new)
		targetSelector: aTarget;
		morph: aMorph;
		yourself! !

!KMTarget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/3/2012 12:51'!
announcer

	^ self morph announcer! !

!KMTarget methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/3/2012 14:46'!
dispatch: buffer

	morph kmDispatcher dispatch: KMBuffer uniqueInstance buffer copy! !

!KMTarget methodsFor: 'accessing' stamp: 'GuillermoPolito 6/24/2012 12:09'!
dispatchOwnerKeystroke: aKeyEvent
	morph owner 
		ifNil: [ ^ self ].
	morph owner kmDispatcher dispatch: KMBuffer uniqueInstance buffer! !

!KMTarget methodsFor: 'accessing' stamp: 'GuillermoPolito 10/20/2011 19:07'!
morph
	^morph! !

!KMTarget methodsFor: 'accessing' stamp: 'GuillermoPolito 5/29/2011 23:50'!
morph: aMorph
	morph := aMorph! !

!KMTarget methodsFor: 'accessing' stamp: 'GuillermoPolito 6/24/2012 12:42'!
ownerTarget
	morph owner ifNil: [ ^nil ].
	^morph owner kmDispatcher target.! !

!KMTarget methodsFor: 'accessing' stamp: 'GuillermoPolito 5/31/2011 11:15'!
realTarget
	^morph perform: self targetSelector! !

!KMTarget methodsFor: 'accessing' stamp: 'GuillermoPolito 5/31/2011 11:18'!
targetSelector
	^targetSelector ifNil: [ #yourself ]! !

!KMTarget methodsFor: 'accessing' stamp: 'GuillermoPolito 5/31/2011 11:10'!
targetSelector: aTargetSelector
	targetSelector := aTargetSelector! !
